
########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_contrl.4gs/fg_funcs.4gl  1.1  Delta: 2/4/91
########################################################################

globals "globals.4gl"

#######################################################################
function age_per_in_seq()
# returns true if the aging period days are non-null and sequential
#######################################################################
#

    if p_rcntrc.age_per1 is null or
       p_rcntrc.age_per2 is null or
       p_rcntrc.age_per3 is null or
       p_rcntrc.age_per1 < 0 or
       p_rcntrc.age_per2 <= p_rcntrc.age_per1 or
       p_rcntrc.age_per3 <= p_rcntrc.age_per1 or
       p_rcntrc.age_per3 <= p_rcntrc.age_per2
     then
         call fg_err(34) # Aging periods must be ascending sequence
         return false
     end if
    return true
end function
# age_per_in_seq()

#######################################################################
function close_setup()
#
#######################################################################
#
    define
        prompt_response char(1),
        tot_ar_balance decimal(12),
        pst_cr_doc_no like strcntrc.cr_doc_no,
        hld_cr_doc_no like strcntrc.cr_doc_no,
        hld_ar_post_no like strcntrc.ar_post_no,
        hld_cr_post_no like strcntrc.cr_post_no,
        oa_amt like strcustr.on_acct_amt,
        p_ropend record like stropend.*,
        chk_amt like stropend.balance,
        chk_disc_amt like stropend.disc_bal,
        chk_less_disc_amt like stropend.balance,
        customer like stropend.cust_code,
        c_rowid integer,
        o_rowid integer,
        x_rowid integer

    open window end_setup at 14,16 with 9 rows, 51 columns
        attribute (border, blue, prompt line last)
    display "===================================================" at 2,1
    display " You have indicated that accounts receivable setup " at 3,1
    display " is complete.  If you wish to continue, the total  " at 4,1
    display " accounts receivable will be summed and displayed. " at 5,1
    display " You will then be given the opportunity to go on   " at 6,1
    display " or to quit.                                       " at 7,1
    display "===================================================" at 8,1
    let prompt_response = null
    while prompt_response matches "[^yYnN]" or
          prompt_response is null
        prompt " Continue? " for prompt_response
    end while
    if upshift(prompt_response) = "N"
    then
        close window end_setup
        let p_rcntrc.ar_balanced = "N"
        return false
    end if
    display " Summing accounts receivable ... please wait.      " at 1,1
    select sum(acct_bal) into tot_ar_balance from strcustr
    display "" at 1,2
    display " Total accounts receivable is ", tot_ar_balance at 1,1
    display " At this time, you may abort this operation.  If   " at 3,1
    display " you continue, transactions will be created for    " at 4,1
    display " open items and amounts on account for customers.  " at 5,1
    display " Once this is done, customer statements and ledger " at 6,1
    display " cards can be printed.                             " at 7,1
    let prompt_response = null
    while prompt_response matches "[^yYnN]" or
          prompt_response is null
        prompt "Continue? " for prompt_response
    end while
    if upshift(prompt_response) = "N"
    then
        close window end_setup
        let p_rcntrc.ar_balanced = "N"
        return false
    end if
    display " Creating transaction records ... please wait.     " at 1,1

    let nastiness_occurred = false     # initialize error flag
    whenever error continue
    lock table strcntrc in share mode  # lock all tables
    if sqlca.sqlcode != 0
    then
        let nastiness_occurred = true
        call fg_err(23) # Could not lock strcntrc
    end if
    if not nastiness_occurred
    then
        lock table strcustr in share mode
        if sqlca.sqlcode != 0
        then
            let nastiness_occurred = true
            call fg_err(24) # Could not lock strcustr
        end if
    end if
    if not nastiness_occurred
    then
        lock table stropend in share mode
        if sqlca.sqlcode != 0
        then
            let nastiness_occurred = true
            call fg_err(25) # Could not lock stropend
        end if
    end if
    if not nastiness_occurred
    then
        lock table stxtranr in share mode
        if sqlca.sqlcode != 0
        then
            let nastiness_occurred = true
            call fg_err(26) # Could not lock stxtranr
        end if
    end if
    if not nastiness_occurred
    then
        lock table strtranr in share mode
        if sqlca.sqlcode != 0
        then
            let nastiness_occurred = true
            call fg_err(27) # Could not lock strtranr
        end if
    end if
    if not nastiness_occurred
    then
        lock table stractvd in share mode
        if sqlca.sqlcode != 0
        then
            let nastiness_occurred = true
            call fg_err(28) # Could not lock stractvd
        end if
    end if
    if nastiness_occurred
    then
        display " a problem occurred ... rolling back.     "
            at 1,1
        sleep 5
        close window end_setup
        let p_rcntrc.ar_balanced = "N"
        whenever error call error_handler
        return false
    end if
    let hld_cr_doc_no = m_rcntrc.cr_doc_no       # save counters
    let hld_ar_post_no = m_rcntrc.ar_post_no
    let hld_cr_post_no = m_rcntrc.cr_post_no
    let m_rcntrc.ar_post_no = m_rcntrc.ar_post_no + 1
    let m_rcntrc.cr_post_no = m_rcntrc.cr_post_no + 1

    call delt_trans()                   # make sure no transactions
# set control "setup completed"
    update strcntrc 
        set strcntrc.ar_balanced = p_rcntrc.ar_balanced,
            strcntrc.cr_doc_no   = m_rcntrc.cr_doc_no,
            strcntrc.cr_post_no  = m_rcntrc.cr_post_no,
            strcntrc.ar_post_no  = m_rcntrc.ar_post_no
    declare c_curs cursor for
        select cust_code, on_acct_amt, rowid from strcustr
            order by cust_code
    foreach c_curs into customer, oa_amt, c_rowid
        let tot_ar_balance = oa_amt
        display " Working on ", customer,
            "                                 " at 9,1

# build on acount transaction
        if oa_amt != 0
        then
            let m_rcntrc.cr_doc_no = m_rcntrc.cr_doc_no + 1
            let pst_cr_doc_no = m_rcntrc.cr_doc_no
            insert into stxtranr values ("CR", pst_cr_doc_no,
                m_rcntrc.cr_post_no, today, today, customer,
                "SETUP ON ACCOUNT AMOUNT")
            if sqlca.sqlcode != 0
            then
                let nastiness_occurred = true
                call fg_err(13) # Could not insert on acct into stxtranr
                exit foreach
            end if
            insert into strtranr values ("CR", pst_cr_doc_no, "SETUP",
                "CR")
            if sqlca.sqlcode != 0
            then
                let nastiness_occurred = true
                call fg_err(14) # Could not insert on acct into strtranr
                exit foreach
            end if
            insert into stractvd values ("CR", pst_cr_doc_no, "A", 0,
                oa_amt)
            if sqlca.sqlcode != 0
            then
                let nastiness_occurred = true
                call fg_err(15) # Could not insert on acct into stractvd
                exit foreach
            end if
        end if

# create transactions for each of the open items
        declare o_curs cursor for
            select rowid, * from stropend
            where stropend.cust_code = customer
        foreach o_curs into o_rowid, p_ropend.*
            let tot_ar_balance = tot_ar_balance + p_ropend.balance
# first do the invoice transactions
            select rowid into x_rowid from stxtranr
                where stxtranr.orig_journal = "AR" and
                    stxtranr.doc_no = p_ropend.doc_no
            if sqlca.sqlcode = notfound
            then
                insert into stxtranr values ("AR", p_ropend.doc_no,
                    m_rcntrc.ar_post_no, today, p_ropend.inv_date,
                    customer, p_ropend.inv_desc)
            else
                update stxtranr set
                    (stxtranr.post_no, stxtranr.post_date) =
                    (m_rcntrc.ar_post_no, today)
                    where rowid = x_rowid
            end if
            if sqlca.sqlcode != 0
            then
                let nastiness_occurred = true
                call fg_err(16) # Could not insert invoice into stxtranr
                exit foreach
            end if
            insert into strtranr values ("AR", p_ropend.doc_no,
                p_ropend.inv_no, "IN")
            if sqlca.sqlcode != 0
            then
                let nastiness_occurred = true
                call fg_err(17) # Could not insert invoice into strtranr
                exit foreach
            end if
            insert into stractvd values ("AR", p_ropend.doc_no, "A",
                p_ropend.doc_no, p_ropend.orig_amount)
            if sqlca.sqlcode != 0
            then
                let nastiness_occurred = true
                call fg_err(18) # Could not insert invoice into stractvd
                exit foreach
            end if

# now do the check/discount transaction(s) if balance has changed
            let chk_amt = p_ropend.balance - p_ropend.orig_amount
            let chk_disc_amt = p_ropend.disc_bal - p_ropend.disc_amt
            if chk_amt = 0 and chk_disc_amt = 0
            then
                continue foreach
            end if
            let m_rcntrc.cr_doc_no = m_rcntrc.cr_doc_no + 1
            let pst_cr_doc_no = m_rcntrc.cr_doc_no
            insert into stxtranr values ("CR", pst_cr_doc_no,
                m_rcntrc.cr_post_no, today, p_ropend.inv_date, customer,
                "SETUP ON PAYMENT AMOUNT")
            if sqlca.sqlcode != 0
            then
                let nastiness_occurred = true
                call fg_err(19) # Could not insert payment into stxtranr
                exit foreach
            end if
            insert into strtranr values ("CR", pst_cr_doc_no, "SETUP",
                "CR")
            if sqlca.sqlcode != 0
            then
                let nastiness_occurred = true
                call fg_err(20) # Could not insert payment into strtranr
                exit foreach
            end if

# check detail
            if chk_amt != 0
            then
                insert into stractvd values ("CR", pst_cr_doc_no, "A",
                    p_ropend.doc_no, chk_amt)
                if sqlca.sqlcode != 0
                then
                    let nastiness_occurred = true
                    call fg_err(21) # Could not insert chk into stractvd
                    exit foreach
                end if
            end if

# discount detail
            if chk_disc_amt != 0
            then
                insert into stractvd values ("CR", pst_cr_doc_no, "D",
                    p_ropend.doc_no, chk_disc_amt)
                if sqlca.sqlcode != 0
                then
                    let nastiness_occurred = true
                    call fg_err(22) # Could not insert dsc into stractvd
                    exit foreach
                end if
            end if
        end foreach
        if nastiness_occurred
        then
            exit foreach
        end if
        update strcustr set acct_bal = tot_ar_balance
            where rowid = c_rowid       # init customer balance
        if sqlca.sqlcode != 0
        then
            let nastiness_occurred = true
            call fg_err(12) # Could not update customer balance
            exit foreach
        end if
    end foreach
    if nastiness_occurred
    then
        display " a problem occurred ... rolling back.     "
            at 1,1
        close window end_setup
        let m_rcntrc.cr_doc_no = hld_cr_doc_no
        let m_rcntrc.ar_post_no = hld_ar_post_no
        let m_rcntrc.cr_post_no = hld_cr_post_no
        let p_rcntrc.ar_balanced = "N"

        # control "setup un-completed"
        update strcntrc
            set strcntrc.ar_balanced = p_rcntrc.ar_balanced,
                strcntrc.cr_doc_no   = m_rcntrc.cr_doc_no,
                strcntrc.cr_post_no  = m_rcntrc.cr_post_no,
                strcntrc.ar_post_no  = m_rcntrc.ar_post_no
        close window end_setup
        return false
    end if
    close window end_setup
    return true

end function
# close_setup()

#######################################################################
function open_setup()
# deletes all a/r transactions from stxtranr, strtranr and stractvd
#######################################################################
# this is dangerous.  if any posting is done to a/r from any journal,
# then the stxtranr record is deleted.  this will leave orphans from
# stgtranr and stgactvd and any other module transaction/activity files
# that were affected.  this is only here so the setup complete flag can
# be reset if it was set to "Y" accidentally.
#
    define
        prompt_response char(1)        # single char Y/N response

    open window opn_setup at 14,16 with 9 rows, 51 columns
        attribute (border, blue, prompt line last)
    display "===================================================" at 2,1
    display " You have indicated that accounts receivable setup " at 3,1
    display " is no longer complete.  If you wish to continue,  " at 4,1
    display " all A/R transactions will be deleted.  The open   " at 5,1
    display " items will remain.  This is generally not a good  " at 6,1
    display " idea if any A/R posting has been done.            " at 7,1
    display "===================================================" at 8,1
    let prompt_response = null
    while prompt_response matches "[^yYnN]" or
          prompt_response is null
        prompt " Continue? " for prompt_response
    end while
    if upshift(prompt_response) = "N"
    then
        close window opn_setup
        let p_rcntrc.ar_balanced = "Y"
        return false
    end if

    display " Deleting A/R transactions ... please wait.        " at 1,1
    whenever error continue
    let nastiness_occurred = false
    lock table stxtranr in share mode   # lock tables for mass delete
    if sqlca.sqlcode != 0
    then
        let nastiness_occurred = true
        call fg_err(29) # Could not lock stxtranr to open setup
    end if
    if not nastiness_occurred
    then
        lock table strtranr in share mode
        if sqlca.sqlcode != 0
        then
            let nastiness_occurred = true
            call fg_err(30) # Could not lock strtranr to open setup
        end if
    end if
    if not nastiness_occurred
    then
        lock table stractvd in share mode
        if sqlca.sqlcode != 0
        then
            let nastiness_occurred = true
            call fg_err(31) # Could not lock stractvd to open setup
        end if
    end if
    if nastiness_occurred
    then
        display " a problem occurred ... rolling back.     "
            at 1,1
        sleep 5
        close window opn_setup
        let p_rcntrc.ar_balanced = "Y"
        whenever error call error_handler
        return false
    end if
    call delt_trans()
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        let sqlca.sqlcode = 0
    end if
    close window opn_setup
    return true
end function
# open_setup()

#######################################################################
function delt_trans()
# delete all a/r transactions
#######################################################################
#
    define
        d_journal like strtranr.orig_journal,
        d_doc_no like strtranr.doc_no,
        d_count integer

# set control "setup completed"
    update strcntrc set strcntrc.ar_balanced = p_rcntrc.ar_balanced
    declare d_curs cursor for
        select orig_journal, doc_no from strtranr
    foreach d_curs into d_journal, d_doc_no
        select count(*) into d_count
        from stgtranr where stgtranr.orig_journal = d_journal and
            stgtranr.doc_no = d_doc_no
        if d_count = 0
        then
            delete from stxtranr
            where stxtranr.orig_journal = d_journal and
                  stxtranr.doc_no = d_doc_no
        end if
    end foreach
    close d_curs
    delete from strtranr
    delete from stractvd

end function
# delt_trans()
