######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

# Local (static) variables
define
    lookup_prep char(1), # Have the lookups been prepared?
    select_prep char(1), # Has the select statement been prepared?
    exit_level smallint, # 0=input, 1=field
    tab_pressed smallint # (boolean) was the tab key pressed?


######################################################################
function llh_input()
# returning -1 if tab pressed (next window), 0 otherwise
######################################################################
#
    # Trap fatal errors
    whenever error call error_handler

    # Initialize some variables
    let exit_level = 0
    let tab_pressed = false


    input p_rcntrc.* without defaults from s_rcntrc.*

      # All entry fields must have before and after field processing
      before field tax_pct call llh_b_field("strcntrc.tax_pct")
        goto next_field
      before field terms_code call llh_b_field("strcntrc.terms_code")
        goto next_field
      before field disc_misc call llh_b_field("strcntrc.disc_misc")
        goto next_field
      before field disc_frght call llh_b_field("strcntrc.disc_frght")
        goto next_field
      before field disc_tax call llh_b_field("strcntrc.disc_tax")
        goto next_field
      before field ar_acct_no call llh_b_field("strcntrc.ar_acct_no")
        goto next_field
      before field ar_sales_acct_no call llh_b_field("strcntrc.ar_sales_acct_no")
        goto next_field
      before field ar_misc_acct_no call llh_b_field("strcntrc.ar_misc_acct_no")
        goto next_field
      before field ar_tax_acct_no call llh_b_field("strcntrc.ar_tax_acct_no")
        goto next_field
      before field ar_fc_acct_no call llh_b_field("strcntrc.ar_fc_acct_no")
        goto next_field
      before field ar_frght_acct_no call llh_b_field("strcntrc.ar_frght_acct_no")
        goto next_field
      before field cr_cash_acct_no call llh_b_field("strcntrc.cr_cash_acct_no")
        goto next_field
      before field cr_disc_acct_no call llh_b_field("strcntrc.cr_disc_acct_no")
        goto next_field
      before field age_datetype call llh_b_field("strcntrc.age_datetype")
        goto next_field
      before field age_dsc1 call llh_b_field("strcntrc.age_dsc1")
        goto next_field
      before field age_dsc2 call llh_b_field("strcntrc.age_dsc2")
        goto next_field
      before field age_dsc3 call llh_b_field("strcntrc.age_dsc3")
        goto next_field
      before field age_dsc4 call llh_b_field("strcntrc.age_dsc4")
        goto next_field
      before field age_per1 call llh_b_field("strcntrc.age_per1")
        goto next_field
      before field age_per2 call llh_b_field("strcntrc.age_per2")
        goto next_field
      before field age_per3 call llh_b_field("strcntrc.age_per3")
        goto next_field
      before field ar_balanced call llh_b_field("strcntrc.ar_balanced")
        goto next_field

      after field tax_pct call llh_a_field()
        goto next_field
      after field terms_code call llh_a_field()
        goto next_field
      after field disc_misc call llh_a_field()
        goto next_field
      after field disc_frght call llh_a_field()
        goto next_field
      after field disc_tax call llh_a_field()
        goto next_field
      after field ar_acct_no call llh_a_field()
        goto next_field
      after field ar_sales_acct_no call llh_a_field()
        goto next_field
      after field ar_misc_acct_no call llh_a_field()
        goto next_field
      after field ar_tax_acct_no call llh_a_field()
        goto next_field
      after field ar_fc_acct_no call llh_a_field()
        goto next_field
      after field ar_frght_acct_no call llh_a_field()
        goto next_field
      after field cr_cash_acct_no call llh_a_field()
        goto next_field
      after field cr_disc_acct_no call llh_a_field()
        goto next_field
      after field age_datetype call llh_a_field()
        goto next_field
      after field age_dsc1 call llh_a_field()
        goto next_field
      after field age_dsc2 call llh_a_field()
        goto next_field
      after field age_dsc3 call llh_a_field()
        goto next_field
      after field age_dsc4 call llh_a_field()
        goto next_field
      after field age_per1 call llh_a_field()
        goto next_field
      after field age_per2 call llh_a_field()
        goto next_field
      after field age_per3 call llh_a_field()
        goto next_field
      after field ar_balanced call llh_a_field()
        goto next_field

      after input
        label end_input:
        let nxt_fld = null

        # Exit directly upon interrupt
        if int_flag then exit input end if

        # Run the 'after field' logic if necessary
        if exit_level >= 1 then call llh_a_field() end if
        if nxt_fld is not null then goto next_field end if

        # Run the 'after input' logic before exiting input
        call llh_a_input()
        if nxt_fld is not null then goto next_field end if
        exit input

      # Event trapping logic
      on key (control-b) let hotkey = 2  goto event
      on key (control-e) let hotkey = 5  goto event
      on key (control-f) let hotkey = 6  goto event
      on key (control-g) let hotkey = 7  goto event
      on key (control-i) let hotkey = 9  goto event
      on key (control-n) let hotkey = 14 goto event
      on key (control-o) let hotkey = 15 goto event
      on key (control-p) let hotkey = 16 goto event
      on key (control-t) let hotkey = 20 goto event
      on key (control-u) let hotkey = 21 goto event
      on key (control-v) let hotkey = 22 goto event
      on key (control-w) let hotkey = 23 goto event
      on key (control-y) let hotkey = 25 goto event
      on key (control-z) let hotkey = 26 goto event
      on key (f5)  let hotkey = 105 goto event
      on key (f6)  let hotkey = 106 goto event
      on key (f7)  let hotkey = 107 goto event
      on key (f8)  let hotkey = 108 goto event
      on key (f9)  let hotkey = 109 goto event
      on key (f10) let hotkey = 110 goto event
      on key (f11) let hotkey = 111 goto event
      on key (f12) let hotkey = 112 goto event
      on key (f13) let hotkey = 113 goto event
      on key (f14) let hotkey = 114 goto event
      on key (f15) let hotkey = 115 goto event
      on key (f16) let hotkey = 116 goto event
      on key (f34) let hotkey = 134 goto event
      on key (f35) let hotkey = 135 goto event
      on key (f36,interrupt) let hotkey = 136 goto event

      # Local event processing
      label event:
        call hot_key("llh_input")  # Map the key to the event
        call llh_event()

      # Programmatic next field logic
      label next_field:
        case
          when nxt_fld is null  # No need to go through 'case'
          when nxt_fld = "tax_pct" next field tax_pct
          when nxt_fld = "terms_code" next field terms_code
          when nxt_fld = "disc_misc" next field disc_misc
          when nxt_fld = "disc_frght" next field disc_frght
          when nxt_fld = "disc_tax" next field disc_tax
          when nxt_fld = "ar_acct_no" next field ar_acct_no
          when nxt_fld = "ar_sales_acct_no" next field ar_sales_acct_no
          when nxt_fld = "ar_misc_acct_no" next field ar_misc_acct_no
          when nxt_fld = "ar_tax_acct_no" next field ar_tax_acct_no
          when nxt_fld = "ar_fc_acct_no" next field ar_fc_acct_no
          when nxt_fld = "ar_frght_acct_no" next field ar_frght_acct_no
          when nxt_fld = "cr_cash_acct_no" next field cr_cash_acct_no
          when nxt_fld = "cr_disc_acct_no" next field cr_disc_acct_no
          when nxt_fld = "age_datetype" next field age_datetype
          when nxt_fld = "age_dsc1" next field age_dsc1
          when nxt_fld = "age_dsc2" next field age_dsc2
          when nxt_fld = "age_dsc3" next field age_dsc3
          when nxt_fld = "age_dsc4" next field age_dsc4
          when nxt_fld = "age_per1" next field age_per1
          when nxt_fld = "age_per2" next field age_per2
          when nxt_fld = "age_per3" next field age_per3
          when nxt_fld = "ar_balanced" next field ar_balanced
          when nxt_fld = "exit input" goto end_input
        end case
    end input

    # Return -1 if tab was pressed
    if tab_pressed
      then return -1
      else return 0
    end if
end function
# llh_input()

######################################################################
function llh_b_field(field_name)
######################################################################
# This function is called from the input function before every field.
# The 'prv_fld' variable contains the field we came from.
# The 'scr_fld' variable contains the field we're going into.
# Set 'nxt_fld' if you want to skip this field or exit input.
#
    define
        field_name char(40),  # Fieldname passed
        prv_fld char(40)      # The field we were just in

    # Convert field_name from 'tab.col' to 'col'
    let field_name = set_fldtab(field_name)

    # Rearrange field names
    let prv_fld = scr_fld
    let scr_fld = field_name
    let nxt_fld = null

    # Require field level exit
    let exit_level = 1

    # Specify fields only if work needs to be done.
    case
      when scr_fld = "terms_code"
    let scratch = "zoom"
      when scr_fld = "ar_acct_no"
    let scratch = "zoom"
      when scr_fld = "ar_sales_acct_no"
    let scratch = "zoom"
      when scr_fld = "ar_misc_acct_no"
    let scratch = "zoom"
      when scr_fld = "ar_tax_acct_no"
    let scratch = "zoom"
      when scr_fld = "ar_fc_acct_no"
    let scratch = "zoom"
      when scr_fld = "ar_frght_acct_no"
    let scratch = "zoom"
      when scr_fld = "cr_cash_acct_no"
    let scratch = "zoom"
      when scr_fld = "cr_disc_acct_no"
    let scratch = "zoom"
    end case

    # Programmed exit
    if nxt_fld is not null then return end if

    # Setup for lib_before
    let scr_fld = prv_fld
    call lib_before(field_name)

end function
# llh_b_field()

######################################################################
function llh_a_field()
######################################################################
# This function is called after every field.
#
    # Reset nxt_fld
    let nxt_fld = null

    # No more exit levels required
    let exit_level = 0

    # After field logic
    case
      when scr_fld = "terms_code"
        if auto_zoom("artermz","strtermr","")
          then let p_rcntrc.terms_code = scratch end if
      when scr_fld = "disc_misc"
        if (p_rcntrc.disc_misc != "Y" and
            p_rcntrc.disc_misc != "N") or
            p_rcntrc.disc_misc is null
        then
            let p_rcntrc.disc_misc = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "disc_misc"
            return
        end if
      when scr_fld = "disc_frght"
        if (p_rcntrc.disc_frght != "Y" and
            p_rcntrc.disc_frght != "N") or
            p_rcntrc.disc_frght is null
        then
            let p_rcntrc.disc_frght = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "disc_frght"
            return
        end if
      when scr_fld = "disc_tax"
        if (p_rcntrc.disc_tax != "Y" and
            p_rcntrc.disc_tax != "N") or
            p_rcntrc.disc_tax is null
        then
            let p_rcntrc.disc_tax = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "disc_tax"
            return
        end if
      when scr_fld = "age_datetype"
        if (p_rcntrc.age_datetype != "I" and
            p_rcntrc.age_datetype != "D") or
            p_rcntrc.age_datetype is null
        then
            let p_rcntrc.age_datetype = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "age_datetype"
            return
        end if
      when scr_fld = "ar_balanced"
        if p_rcntrc.ar_balanced is null or
          (p_rcntrc.ar_balanced != "Y" and
           p_rcntrc.ar_balanced != "N")
        then
            let p_rcntrc.ar_balanced = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "ar_balanced"
        end if
    end case

    # Programmed exit
    if nxt_fld is not null then return end if

    # This (among other things) sets data_changed
    call lib_after()

    # After data_changed logic
    if data_changed
    then
        case
          when scr_fld = "terms_code"
            # Perform lookups
            if llh_lookup("look9",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "terms_code"
                return
            end if
          when scr_fld = "ar_acct_no"
            # Perform lookups
            if llh_lookup("look1",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "ar_acct_no"
                return
            end if
            if p_rcntrc.ar_acct_no is not null
            then
                if p_rcntrc.ar_acct_no < m_xcntrc.curr_asset or
                    p_rcntrc.ar_acct_no >= m_xcntrc.fixed_asset
                then
                    # AR account must be within asset range
                    call fg_err(4)
                    let nxt_fld = "ar_acct_no"
                end if
            end if
          when scr_fld = "ar_sales_acct_no"
            # Perform lookups
            if llh_lookup("look2",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "ar_sales_acct_no"
                return
            end if
            if p_rcntrc.ar_sales_acct_no is not null
            then
                if p_rcntrc.ar_sales_acct_no < m_xcntrc.income or
                    p_rcntrc.ar_sales_acct_no >= m_xcntrc.cost_goods
                then
                    # sales account must be within income range
                    call fg_err(5)
                    let nxt_fld = "ar_sales_acct_no"
                end if
            end if
          when scr_fld = "ar_misc_acct_no"
            # Perform lookups
            if llh_lookup("look3",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "ar_misc_acct_no"
                return
            end if
            if p_rcntrc.ar_misc_acct_no is not null
            then
                if p_rcntrc.ar_misc_acct_no < m_xcntrc.income or
                    p_rcntrc.ar_misc_acct_no >= m_xcntrc.cost_goods
                then
                    # misc. AR account must be within income range
                    call fg_err(9)
                    let nxt_fld = "ar_misc_acct_no"
                end if
            end if
          when scr_fld = "ar_tax_acct_no"
            # Perform lookups
            if llh_lookup("look4",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "ar_tax_acct_no"
                return
            end if
            if p_rcntrc.ar_tax_acct_no is not null
            then
                if p_rcntrc.ar_tax_acct_no < m_xcntrc.curr_liab or
                    p_rcntrc.ar_tax_acct_no >= m_xcntrc.long_term_liab
                then
                    # tax account must be within current liability range
                    call fg_err(6)
                    let nxt_fld = "ar_tax_acct_no"
                end if
            end if
          when scr_fld = "ar_fc_acct_no"
            # Perform lookups
            if llh_lookup("look5",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "ar_fc_acct_no"
                return
            end if
            if p_rcntrc.ar_fc_acct_no is not null
            then
                if p_rcntrc.ar_fc_acct_no < m_xcntrc.income or
                    p_rcntrc.ar_fc_acct_no >= m_xcntrc.cost_goods
                then
                    # finance charge account must be within income range
                    call fg_err(7)
                    let nxt_fld = "ar_fc_acct_no"
                end if
            end if
          when scr_fld = "ar_frght_acct_no"
            # Perform lookups
            if llh_lookup("look6",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "ar_frght_acct_no"
                return
            end if
            if p_rcntrc.ar_frght_acct_no is not null
            then
                if p_rcntrc.ar_frght_acct_no < m_xcntrc.income or
                    p_rcntrc.ar_frght_acct_no >= m_xcntrc.cost_goods
                then
                    # freight account must be with income range
                    call fg_err(8)
                    let nxt_fld = "ar_frght_acct_no"
                end if
            end if
          when scr_fld = "cr_cash_acct_no"
            # Perform lookups
            if llh_lookup("look7",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "cr_cash_acct_no"
                return
            end if
            if p_rcntrc.cr_cash_acct_no is not null
            then
               if p_rcntrc.cr_cash_acct_no < m_xcntrc.curr_asset or
                   p_rcntrc.cr_cash_acct_no >= m_xcntrc.fixed_asset
                then
                    # cash account must be within current assets range
                    call fg_err(10)
                    let nxt_fld = "cr_cash_acct_no"
                end if
            end if
          when scr_fld = "cr_disc_acct_no"
            # Perform lookups
            if llh_lookup("look8",true) = false and
              length(this_data) != 0
            then
                let nxt_fld = "cr_disc_acct_no"
                return
            end if
            if p_rcntrc.cr_disc_acct_no is not null
            then
                if p_rcntrc.cr_disc_acct_no < m_xcntrc.income or
                    p_rcntrc.cr_disc_acct_no >= m_xcntrc.cost_goods
                then
                    # discount account must be within income range
                    call fg_err(11)
                    let nxt_fld = "cr_disc_acct_no"
                end if
            end if
        end case
    end if

end function
# llh_a_field()

######################################################################
function llh_a_input()
######################################################################
# This function is called whenever the input statement exits
# (except due to an interrupt).  If you don't want the input session
# to end, set the nxt_fld variable to contain the field to be placed
# back into.
#
    # check for required values
    if mustfill(p_rcntrc.tax_pct,"Default Tax Rate")
      then let nxt_fld = "tax_pct" return end if
    if mustfill(p_rcntrc.terms_code,"Terms Code")
      then let nxt_fld = "terms_code" return end if
    if mustfill(p_rcntrc.ar_acct_no,"A/R Account Number")
      then let nxt_fld = "ar_acct_no" return end if
    if mustfill(p_rcntrc.ar_sales_acct_no,"Sales Account Number")
      then let nxt_fld = "ar_sales_acct_no" return end if
    if mustfill(p_rcntrc.ar_tax_acct_no,"Tax Account Number")
      then let nxt_fld = "ar_tax_acct_no" return end if
    if mustfill(p_rcntrc.ar_fc_acct_no,"Finance Charge Account Number")
      then let nxt_fld = "ar_fc_acct_no" return end if
    if mustfill(p_rcntrc.ar_frght_acct_no,"Freight Account Number")
      then let nxt_fld = "ar_frght_acct_no" return end if
    if mustfill(p_rcntrc.ar_misc_acct_no,"Misc. Account Number")
      then let nxt_fld = "ar_misc_acct_no" return end if
    if mustfill(p_rcntrc.cr_cash_acct_no,"Cash Account Number")
      then let nxt_fld = "cr_cash_acct_no" return end if
    if mustfill(p_rcntrc.cr_disc_acct_no,"Discount Account Number")
      then let nxt_fld = "cr_disc_acct_no" return end if

    if age_per_in_seq()
      then else let nxt_fld = "age_per1" return end if

    if not tab_pressed
    then
        if p_rcntrc.ar_balanced = "Y" and orig_ar_balanced = "N"
        then
            if close_setup() = false
            then
                call ok_cancel("Y")
                let int_flag = -1
            end if
        end if
        if p_rcntrc.ar_balanced = "N" and orig_ar_balanced = "Y"
        then
            if open_setup() = false
            then
                call ok_cancel("Y")
                let int_flag = -1
            end if
        end if
    end if

end function
# llh_a_input()

######################################################################
function llh_event()
######################################################################
# This function is called whenever the user presses an event key.
# The event is mapped to the 'scr_funct' variable and processed here.
#
    # Reset tab pressed to false
    let tab_pressed = false
    case
      when scr_funct = "zoom" and infield(ar_acct_no)
        let scratch =
          " stxchrtr.acct_cat = \"A\""
        if zoom("chrtz","(see scratch)")
        then
            let p_rcntrc.ar_acct_no = scratch
            let nxt_fld = "ar_acct_no"
        end if
      when scr_funct = "zoom" and infield(ar_sales_acct_no)
        let scratch =
          " stxchrtr.acct_cat = \"D\""
        if zoom("chrtz","(see scratch)")
        then
            let p_rcntrc.ar_sales_acct_no = scratch
            let nxt_fld = "ar_sales_acct_no"
        end if
      when scr_funct = "zoom" and infield(ar_misc_acct_no)
        let scratch =
          " stxchrtr.acct_cat = \"D\""
        if zoom("chrtz","(see scratch)")
        then
            let p_rcntrc.ar_misc_acct_no = scratch
            let nxt_fld = "ar_misc_acct_no"
        end if
      when scr_funct = "zoom" and infield(cr_cash_acct_no)
        let scratch =
          " stxchrtr.acct_cat = \"A\""
        if zoom("chrtz","(see scratch)")
        then
            let p_rcntrc.cr_cash_acct_no = scratch
            let nxt_fld = "cr_cash_acct_no"
        end if
      when scr_funct = "zoom" and infield(ar_tax_acct_no)
        let scratch =
          " stxchrtr.acct_cat = \"B\""
        if zoom("chrtz","(see scratch)")
        then
            let p_rcntrc.ar_tax_acct_no = scratch
            let nxt_fld = "ar_tax_acct_no"
        end if
      when scr_funct = "zoom" and infield(ar_fc_acct_no)
        let scratch =
          " stxchrtr.acct_cat = \"D\""
        if zoom("chrtz","(see scratch)")
        then
            let p_rcntrc.ar_fc_acct_no = scratch
            let nxt_fld = "ar_fc_acct_no"
        end if
      when scr_funct = "zoom" and infield(ar_frght_acct_no)
        let scratch =
          " stxchrtr.acct_cat = \"D\""
        if zoom("chrtz","(see scratch)")
        then
            let p_rcntrc.ar_frght_acct_no = scratch
            let nxt_fld = "ar_frght_acct_no"
        end if
      when scr_funct = "zoom" and infield(cr_disc_acct_no)
        let scratch =
          " stxchrtr.acct_cat = \"D\""
        if zoom("chrtz","(see scratch)")
        then
            let p_rcntrc.cr_disc_acct_no = scratch
            let nxt_fld = "cr_disc_acct_no"
        end if
      when scr_funct = "zoom" and infield(terms_code)
        if zoom("artermz","")
        then
            let p_rcntrc.terms_code = scratch
            let nxt_fld = "terms_code"
        end if
      when scr_funct = "accept"
        let nxt_fld = "exit input"
      when scr_funct = "tab" or scr_funct = "btab"
        let tab_pressed = true
        let nxt_fld = "exit input"
      when scr_funct = "cancel"
        if no_cancel()
        then
          let int_flag = false
          let nxt_fld = null
        else
          let int_flag = true
          let nxt_fld = "exit input"
        end if
    end case
    let scr_funct = ""

end function
# llh_event()

######################################################################
function llh_setdata()
######################################################################
# This function is called to set the this_data global variable.
#
    case
      when scr_fld = "tax_pct"
        call set_data(p_rcntrc.tax_pct)
      when scr_fld = "terms_code"
        call set_data(p_rcntrc.terms_code)
      when scr_fld = "disc_misc"
        call set_data(p_rcntrc.disc_misc)
      when scr_fld = "disc_frght"
        call set_data(p_rcntrc.disc_frght)
      when scr_fld = "disc_tax"
        call set_data(p_rcntrc.disc_tax)
      when scr_fld = "ar_acct_no"
        call set_data(p_rcntrc.ar_acct_no)
      when scr_fld = "ar_sales_acct_no"
        call set_data(p_rcntrc.ar_sales_acct_no)
      when scr_fld = "ar_misc_acct_no"
        call set_data(p_rcntrc.ar_misc_acct_no)
      when scr_fld = "ar_tax_acct_no"
        call set_data(p_rcntrc.ar_tax_acct_no)
      when scr_fld = "ar_fc_acct_no"
        call set_data(p_rcntrc.ar_fc_acct_no)
      when scr_fld = "ar_frght_acct_no"
        call set_data(p_rcntrc.ar_frght_acct_no)
      when scr_fld = "cr_cash_acct_no"
        call set_data(p_rcntrc.cr_cash_acct_no)
      when scr_fld = "cr_disc_acct_no"
        call set_data(p_rcntrc.cr_disc_acct_no)
      when scr_fld = "age_datetype"
        call set_data(p_rcntrc.age_datetype)
      when scr_fld = "age_dsc1"
        call set_data(p_rcntrc.age_dsc1)
      when scr_fld = "age_dsc2"
        call set_data(p_rcntrc.age_dsc2)
      when scr_fld = "age_dsc3"
        call set_data(p_rcntrc.age_dsc3)
      when scr_fld = "age_dsc4"
        call set_data(p_rcntrc.age_dsc4)
      when scr_fld = "age_per1"
        call set_data(p_rcntrc.age_per1)
      when scr_fld = "age_per2"
        call set_data(p_rcntrc.age_per2)
      when scr_fld = "age_per3"
        call set_data(p_rcntrc.age_per3)
      when scr_fld = "ar_balanced"
        call set_data(p_rcntrc.ar_balanced)
    end case
end function
# llh_setdata()

######################################################################
function llh_high()
######################################################################
# This function highlights the specified field name.
# Only input type fields need to be specified.
#
    case
      when scr_fld = "tax_pct"
        display by name p_rcntrc.tax_pct attribute(reverse)
      when scr_fld = "terms_code"
        display by name p_rcntrc.terms_code attribute(reverse)
      when scr_fld = "disc_misc"
        display by name p_rcntrc.disc_misc attribute(reverse)
      when scr_fld = "disc_frght"
        display by name p_rcntrc.disc_frght attribute(reverse)
      when scr_fld = "disc_tax"
        display by name p_rcntrc.disc_tax attribute(reverse)
      when scr_fld = "ar_acct_no"
        display by name p_rcntrc.ar_acct_no attribute(reverse)
      when scr_fld = "ar_sales_acct_no"
        display by name p_rcntrc.ar_sales_acct_no attribute(reverse)
      when scr_fld = "ar_misc_acct_no"
        display by name p_rcntrc.ar_misc_acct_no attribute(reverse)
      when scr_fld = "ar_tax_acct_no"
        display by name p_rcntrc.ar_tax_acct_no attribute(reverse)
      when scr_fld = "ar_fc_acct_no"
        display by name p_rcntrc.ar_fc_acct_no attribute(reverse)
      when scr_fld = "ar_frght_acct_no"
        display by name p_rcntrc.ar_frght_acct_no attribute(reverse)
      when scr_fld = "cr_cash_acct_no"
        display by name p_rcntrc.cr_cash_acct_no attribute(reverse)
      when scr_fld = "cr_disc_acct_no"
        display by name p_rcntrc.cr_disc_acct_no attribute(reverse)
      when scr_fld = "age_datetype"
        display by name p_rcntrc.age_datetype attribute(reverse)
      when scr_fld = "age_dsc1"
        display by name p_rcntrc.age_dsc1 attribute(reverse)
      when scr_fld = "age_dsc2"
        display by name p_rcntrc.age_dsc2 attribute(reverse)
      when scr_fld = "age_dsc3"
        display by name p_rcntrc.age_dsc3 attribute(reverse)
      when scr_fld = "age_dsc4"
        display by name p_rcntrc.age_dsc4 attribute(reverse)
      when scr_fld = "age_per1"
        display by name p_rcntrc.age_per1 attribute(reverse)
      when scr_fld = "age_per2"
        display by name p_rcntrc.age_per2 attribute(reverse)
      when scr_fld = "age_per3"
        display by name p_rcntrc.age_per3 attribute(reverse)
      when scr_fld = "ar_balanced"
        display by name p_rcntrc.ar_balanced attribute(reverse)
    end case
end function
# llh_high()

######################################################################
function llh_display()
######################################################################
# This function displays all p_* variables onto the screen
#
    display p_rcntrc.* to s_rcntrc.*  attribute(red)
end function
# llh_display()

######################################################################
function llh_p_prep()
######################################################################
# This function creates the p_* record from the m_* record
#
    let p_rcntrc.tax_pct = m_rcntrc.tax_pct
    let p_rcntrc.terms_code = m_rcntrc.terms_code
    let p_rcntrc.disc_misc = m_rcntrc.disc_misc
    let p_rcntrc.disc_frght = m_rcntrc.disc_frght
    let p_rcntrc.disc_tax = m_rcntrc.disc_tax
    let p_rcntrc.ar_acct_no = m_rcntrc.ar_acct_no
    let p_rcntrc.ar_sales_acct_no = m_rcntrc.ar_sales_acct_no
    let p_rcntrc.ar_misc_acct_no = m_rcntrc.ar_misc_acct_no
    let p_rcntrc.ar_tax_acct_no = m_rcntrc.ar_tax_acct_no
    let p_rcntrc.ar_fc_acct_no = m_rcntrc.ar_fc_acct_no
    let p_rcntrc.ar_frght_acct_no = m_rcntrc.ar_frght_acct_no
    let p_rcntrc.cr_cash_acct_no = m_rcntrc.cr_cash_acct_no
    let p_rcntrc.cr_disc_acct_no = m_rcntrc.cr_disc_acct_no
    let p_rcntrc.age_datetype = m_rcntrc.age_datetype
    let p_rcntrc.age_dsc1 = m_rcntrc.age_dsc1
    let p_rcntrc.age_dsc2 = m_rcntrc.age_dsc2
    let p_rcntrc.age_dsc3 = m_rcntrc.age_dsc3
    let p_rcntrc.age_dsc4 = m_rcntrc.age_dsc4
    let p_rcntrc.age_per1 = m_rcntrc.age_per1
    let p_rcntrc.age_per2 = m_rcntrc.age_per2
    let p_rcntrc.age_per3 = m_rcntrc.age_per3
    let p_rcntrc.ar_balanced = m_rcntrc.ar_balanced

    # Perform lookups
    if llh_lookup("look1",false) then end if
    if llh_lookup("look2",false) then end if
    if llh_lookup("look3",false) then end if
    if llh_lookup("look6",false) then end if
    if llh_lookup("look4",false) then end if
    if llh_lookup("look5",false) then end if
    if llh_lookup("look7",false) then end if
    if llh_lookup("look8",false) then end if
    if llh_lookup("look9",false) then end if

    if m_rcntrc.ar_doc_no is null
      then let m_rcntrc.ar_doc_no = 1 end if
    if m_rcntrc.ar_post_no is null
      then let m_rcntrc.ar_post_no = 1 end if
    if m_rcntrc.cr_doc_no is null
      then let m_rcntrc.cr_doc_no = 1 end if
    if m_rcntrc.cr_post_no is null
      then let m_rcntrc.cr_post_no = 1 end if
    let orig_ar_balanced = p_rcntrc.ar_balanced

end function
# llh_p_prep()

######################################################################
function llh_m_prep()
######################################################################
# This function creates the m_* record from the p_* record
#
    let m_rcntrc.tax_pct = p_rcntrc.tax_pct
    let m_rcntrc.terms_code = p_rcntrc.terms_code
    let m_rcntrc.disc_misc = p_rcntrc.disc_misc
    let m_rcntrc.disc_frght = p_rcntrc.disc_frght
    let m_rcntrc.disc_tax = p_rcntrc.disc_tax
    let m_rcntrc.ar_acct_no = p_rcntrc.ar_acct_no
    let m_rcntrc.ar_sales_acct_no = p_rcntrc.ar_sales_acct_no
    let m_rcntrc.ar_misc_acct_no = p_rcntrc.ar_misc_acct_no
    let m_rcntrc.ar_tax_acct_no = p_rcntrc.ar_tax_acct_no
    let m_rcntrc.ar_fc_acct_no = p_rcntrc.ar_fc_acct_no
    let m_rcntrc.ar_frght_acct_no = p_rcntrc.ar_frght_acct_no
    let m_rcntrc.cr_cash_acct_no = p_rcntrc.cr_cash_acct_no
    let m_rcntrc.cr_disc_acct_no = p_rcntrc.cr_disc_acct_no
    let m_rcntrc.age_datetype = p_rcntrc.age_datetype
    let m_rcntrc.age_dsc1 = p_rcntrc.age_dsc1
    let m_rcntrc.age_dsc2 = p_rcntrc.age_dsc2
    let m_rcntrc.age_dsc3 = p_rcntrc.age_dsc3
    let m_rcntrc.age_dsc4 = p_rcntrc.age_dsc4
    let m_rcntrc.age_per1 = p_rcntrc.age_per1
    let m_rcntrc.age_per2 = p_rcntrc.age_per2
    let m_rcntrc.age_per3 = p_rcntrc.age_per3
    let m_rcntrc.ar_balanced = p_rcntrc.ar_balanced
end function
# llh_m_prep()

######################################################################
function llh_read(ring_rowid)
######################################################################
# This function loads the header p_* record elements.
# It first loads the m_* record from disk, then it
# calls the p_prep routine to fill the p_* record elements.
#
    define
        ring_rowid  integer     # rowid of record to read

    # Prepare the cursor upon first invocation
    if select_prep is null
    then
        let select_prep = "Y"
        let scratch = "select * from strcntrc where rowid = ?"
        prepare read_specs from scratch
        declare h_cursor cursor for read_specs
    end if

    # Read the header record
    open h_cursor using ring_rowid
    fetch h_cursor into m_rcntrc.*
    if sqlca.sqlcode != 0 then return end if
    let q_rcntrc.row_id = ring_rowid
    close h_cursor
    call llh_p_prep()
end function
# llh_read()

######################################################################
function llh_delete(ring_rowid)
######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    delete from strcntrc
        where rowid = ring_rowid
end function
# llh_delete()

######################################################################
function llh_add()
######################################################################
# This function inserts data into the header table.
#
    define
        new_rowid integer  # Rowid after insert
    # Insert the data
    insert into strcntrc values(m_rcntrc.*)
    let new_rowid = sqlca.sqlerrd[6]

    # Reset rowid
    let sqlca.sqlerrd[6] = new_rowid

end function
# llh_add()

######################################################################
function llh_update(ring_rowid)
######################################################################
#
    define
        ring_rowid  integer     # rowid passed
    update strcntrc set strcntrc.* = m_rcntrc.*
      where rowid = ring_rowid
end function
# llh_update()

######################################################################
function llh_lookup(tbl_name,mustfind)
# returning false if notfound
######################################################################
# This is the lookup function.  It is passed a table to lookup, and
# based on that, it looks up the key and fills any variables for
# that table.  The lookup function will produce the error if it is
# called with mustfind=true, and a notfound situation exists.
#
    define
        tbl_name char(18),  # Lookup table name
        stat integer,       # Value of sqlca.sqlcode after lookup
        mustfind smallint   # (boolean) produce an error if notfound?

    # Prepare cursors upon first call to this function
    if lookup_prep is null
    then
        let lookup_prep = "Y"
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_look1 from scratch
        declare cur_look1 cursor for str_look1
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_look2 from scratch
        declare cur_look2 cursor for str_look2
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_look3 from scratch
        declare cur_look3 cursor for str_look3
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_look6 from scratch
        declare cur_look6 cursor for str_look6
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_look4 from scratch
        declare cur_look4 cursor for str_look4
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_look5 from scratch
        declare cur_look5 cursor for str_look5
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_look7 from scratch
        declare cur_look7 cursor for str_look7
        let scratch = "select rowid ",
          "from stxchrtr where ",
          " stxchrtr.acct_no = ?"
        prepare str_look8 from scratch
        declare cur_look8 cursor for str_look8
        let scratch = "select terms_desc ",
          "from strtermr where ",
          " strtermr.terms_code = ?"
        prepare str_look9 from scratch
        declare cur_look9 cursor for str_look9
    end if

    # Perform the lookup
    case
      when tbl_name = "look1"
        open cur_look1 using p_rcntrc.ar_acct_no
        fetch cur_look1 into scratch
        let stat = sqlca.sqlcode
        close cur_look1
      when tbl_name = "look2"
        open cur_look2 using p_rcntrc.ar_sales_acct_no
        fetch cur_look2 into scratch
        let stat = sqlca.sqlcode
        close cur_look2
      when tbl_name = "look3"
        open cur_look3 using p_rcntrc.ar_misc_acct_no
        fetch cur_look3 into scratch
        let stat = sqlca.sqlcode
        close cur_look3
      when tbl_name = "look6"
        open cur_look6 using p_rcntrc.ar_frght_acct_no
        fetch cur_look6 into scratch
        let stat = sqlca.sqlcode
        close cur_look6
      when tbl_name = "look4"
        open cur_look4 using p_rcntrc.ar_tax_acct_no
        fetch cur_look4 into scratch
        let stat = sqlca.sqlcode
        close cur_look4
      when tbl_name = "look5"
        open cur_look5 using p_rcntrc.ar_fc_acct_no
        fetch cur_look5 into scratch
        let stat = sqlca.sqlcode
        close cur_look5
      when tbl_name = "look7"
        open cur_look7 using p_rcntrc.cr_cash_acct_no
        fetch cur_look7 into scratch
        let stat = sqlca.sqlcode
        close cur_look7
      when tbl_name = "look8"
        open cur_look8 using p_rcntrc.cr_disc_acct_no
        fetch cur_look8 into scratch
        let stat = sqlca.sqlcode
        close cur_look8
      when tbl_name = "look9"
        open cur_look9 using p_rcntrc.terms_code
        fetch cur_look9 into p_rcntrc.terms_desc
        let stat = sqlca.sqlcode
        close cur_look9
    end case

    # No mustfind if this_data is empty
    if length(this_data) = 0 then let mustfind = false end if

    # Send notfound message to user (if requested)
    let sqlca.sqlcode = stat
    if mustfind and stat = notfound
      then call scr_error("lookup=notfound",tbl_name)
    end if
    let sqlca.sqlcode = 0

    # Return false if lookup failed and empty into fields
    if stat = notfound
    then
        case
          when tbl_name = "look1"
            initialize scratch to null
          when tbl_name = "look2"
            initialize scratch to null
          when tbl_name = "look3"
            initialize scratch to null
          when tbl_name = "look6"
            initialize scratch to null
          when tbl_name = "look4"
            initialize scratch to null
          when tbl_name = "look5"
            initialize scratch to null
          when tbl_name = "look7"
            initialize scratch to null
          when tbl_name = "look8"
            initialize scratch to null
          when tbl_name = "look9"
            initialize p_rcntrc.terms_desc to null
        end case
        return false
    else
        return true
    end if
end function
# llh_lookup()

