######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

######################################################################
function mlh_init()
# returning the initial find group filter string.
######################################################################
# This function serves two purposes.
# It is called only once upon program invocation, so you may use
# it as a place to run initialization routines.
# It requires a return value of the default select group.
# examples of return values:
#   return "1=1" (select all rows)
#   return "1=0" (select no rows)
#   return "customer_num is not null" (select non-null customer_num's)
#   return "posted = \"N\"" (select only unposted documents)
#
    # Trap fatal errors
    whenever error call error_handler

    return "1=1"
end function
# mlh_init()

######################################################################
function mlh_clear()
######################################################################
#
    initialize p_rcntrc.* to null
    initialize q_rcntrc.* to null
    initialize m_rcntrc.* to null
end function
# mlh_clear

######################################################################
function mlh_construct()
# returning criteria
######################################################################
#
    construct scratch
      on
        strcntrc.tax_pct, strcntrc.terms_code, strcntrc.disc_misc,
        strcntrc.disc_frght, strcntrc.disc_tax, strcntrc.ar_acct_no,
        strcntrc.ar_sales_acct_no, strcntrc.ar_misc_acct_no,
        strcntrc.ar_tax_acct_no, strcntrc.ar_fc_acct_no,
        strcntrc.ar_frght_acct_no, strcntrc.cr_cash_acct_no,
        strcntrc.cr_disc_acct_no, strcntrc.age_datetype,
        strcntrc.age_dsc1, strcntrc.age_dsc2, strcntrc.age_dsc3,
        strcntrc.age_dsc4, strcntrc.age_per1, strcntrc.age_per2,
        strcntrc.age_per3, strcntrc.ar_balanced
      from
        s_rcntrc.tax_pct, s_rcntrc.terms_code, s_rcntrc.disc_misc,
        s_rcntrc.disc_frght, s_rcntrc.disc_tax, s_rcntrc.ar_acct_no,
        s_rcntrc.ar_sales_acct_no, s_rcntrc.ar_misc_acct_no,
        s_rcntrc.ar_tax_acct_no, s_rcntrc.ar_fc_acct_no,
        s_rcntrc.ar_frght_acct_no, s_rcntrc.cr_cash_acct_no,
        s_rcntrc.cr_disc_acct_no, s_rcntrc.age_datetype,
        s_rcntrc.age_dsc1, s_rcntrc.age_dsc2, s_rcntrc.age_dsc3,
        s_rcntrc.age_dsc4, s_rcntrc.age_per1, s_rcntrc.age_per2,
        s_rcntrc.age_per3, s_rcntrc.ar_balanced
    return scratch[1,512]
end function
# mlh_construct

######################################################################
function mlh_cursor()
######################################################################
# This function defines the table, filter, and ordering portions of
# the select statement used to build the FourGen scroller.
#
    call put_vararg("strcntrc")
    call put_vararg("")
    call put_vararg("")
end function
# mlh_cursor()

######################################################################
function mlh_key()
# returning tablename, key_field [,key_field]... in (vararg) scratch
######################################################################
# This function returns (in vararg scratch) the name of the main table
# for this screen and the field name(s) and their data that build
# the unique key into this table.
# This is used to determine the unique key for additional fields,
# notes, and other items that may key off this document.  The key
# field(s) must not exceed 30 characters total.
# The first vararg call is the table name.  The following varargs are
# called in pairs.  The first of the pair is the column name, and
# the second in the pair is the column data.
#
    call put_vararg("strcntrc")
    call put_vararg("ar_balanced")
    call put_vararg(m_rcntrc.ar_balanced)
end function
# mlh_key()
