########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_contrl.4gs/screen.trg  1.2  Delta: 1/9/91
########################################################################
defaults

    define
        nastiness_occurred smallint,   # error flag
        orig_ar_balanced like strcntrc.ar_balanced,
        m_xcntrc record like stxcntrc.*,;

    libraries
        ../../all.4gm/lib.a;

    after_init
        call xcontrol() returning m_xcntrc.*;

    at_eof
##################################################################
function ok_browse()
# returning true or false based upon ok to delete
##################################################################
#
call fg_err(32) #This function has been disabled 
return false
end function
# ok_browse

##################################################################
function ok_delete()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_delete

##################################################################
function ok_add()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_add

##################################################################
function ok_find()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_find

##################################################################
function ok_next()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_next

##################################################################
function ok_prev()
# returning true or false based upon ok to delete
##################################################################
#

call fg_err(32) #This function has been disabled 
return false
end function
# ok_prev;

input 1

    on_screen_record_prep
        if m_rcntrc.ar_doc_no is null 
          then let m_rcntrc.ar_doc_no = 1 end if
        if m_rcntrc.ar_post_no is null
          then let m_rcntrc.ar_post_no = 1 end if
        if m_rcntrc.cr_doc_no is null 
          then let m_rcntrc.cr_doc_no = 1 end if
        if m_rcntrc.cr_post_no is null
          then let m_rcntrc.cr_post_no = 1 end if
        let orig_ar_balanced = p_rcntrc.ar_balanced;

    after_input
        # check for required values
        if mustfill(p_rcntrc.tax_pct,"Default Tax Rate")
          then let nxt_fld = "tax_pct" return end if
        if mustfill(p_rcntrc.terms_code,"Terms Code")
          then let nxt_fld = "terms_code" return end if
        if mustfill(p_rcntrc.ar_acct_no,"A/R Account Number")
          then let nxt_fld = "ar_acct_no" return end if
        if mustfill(p_rcntrc.ar_sales_acct_no,"Sales Account Number")
          then let nxt_fld = "ar_sales_acct_no" return end if
        if mustfill(p_rcntrc.ar_tax_acct_no,"Tax Account Number")
          then let nxt_fld = "ar_tax_acct_no" return end if
        if mustfill(p_rcntrc.ar_fc_acct_no,"Finance Charge Account Number")
          then let nxt_fld = "ar_fc_acct_no" return end if
        if mustfill(p_rcntrc.ar_frght_acct_no,"Freight Account Number")
          then let nxt_fld = "ar_frght_acct_no" return end if
        if mustfill(p_rcntrc.ar_misc_acct_no,"Misc. Account Number")
          then let nxt_fld = "ar_misc_acct_no" return end if
        if mustfill(p_rcntrc.cr_cash_acct_no,"Cash Account Number")
          then let nxt_fld = "cr_cash_acct_no" return end if
        if mustfill(p_rcntrc.cr_disc_acct_no,"Discount Account Number")
          then let nxt_fld = "cr_disc_acct_no" return end if

        if age_per_in_seq()
          then else let nxt_fld = "age_per1" return end if

        if not tab_pressed
        then
            if p_rcntrc.ar_balanced = "Y" and orig_ar_balanced = "N"
            then 
                if close_setup() = false
                then
                    call ok_cancel("Y")
                    let int_flag = -1
                end if
            end if
            if p_rcntrc.ar_balanced = "N" and orig_ar_balanced = "Y"
            then 
                if open_setup() = false
                then
                    call ok_cancel("Y")
                    let int_flag = -1
                end if
            end if
        end if;

    after_field ar_balanced
        if p_rcntrc.ar_balanced is null or
          (p_rcntrc.ar_balanced != "Y" and
           p_rcntrc.ar_balanced != "N")
        then
            let p_rcntrc.ar_balanced = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "ar_balanced"
        end if;

    after_field age_datetype
        if (p_rcntrc.age_datetype != "I" and
            p_rcntrc.age_datetype != "D") or
            p_rcntrc.age_datetype is null
        then 
            let p_rcntrc.age_datetype = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "age_datetype"
            return
        end if;

    after_change_in ar_acct_no
        if p_rcntrc.ar_acct_no is not null
        then
            if p_rcntrc.ar_acct_no < m_xcntrc.curr_asset or
                p_rcntrc.ar_acct_no >= m_xcntrc.fixed_asset
            then
                # AR account must be within asset range
                call fg_err(4) 
                let nxt_fld = "ar_acct_no"
            end if
        end if;

    after_change_in ar_sales_acct_no
        if p_rcntrc.ar_sales_acct_no is not null
        then
            if p_rcntrc.ar_sales_acct_no < m_xcntrc.income or
                p_rcntrc.ar_sales_acct_no >= m_xcntrc.cost_goods
            then
                # sales account must be within income range
                call fg_err(5) 
                let nxt_fld = "ar_sales_acct_no"
            end if 
        end if;

    after_change_in ar_tax_acct_no
        if p_rcntrc.ar_tax_acct_no is not null
        then
            if p_rcntrc.ar_tax_acct_no < m_xcntrc.curr_liab or
                p_rcntrc.ar_tax_acct_no >= m_xcntrc.long_term_liab
            then
                # tax account must be within current liability range
                call fg_err(6) 
                let nxt_fld = "ar_tax_acct_no"
            end if
        end if;

    after_change_in ar_fc_acct_no
        if p_rcntrc.ar_fc_acct_no is not null
        then
            if p_rcntrc.ar_fc_acct_no < m_xcntrc.income or
                p_rcntrc.ar_fc_acct_no >= m_xcntrc.cost_goods
            then
                # finance charge account must be within income range
                call fg_err(7) 
                let nxt_fld = "ar_fc_acct_no"
            end if
        end if;

    after_change_in ar_frght_acct_no
        if p_rcntrc.ar_frght_acct_no is not null
        then
            if p_rcntrc.ar_frght_acct_no < m_xcntrc.income or
                p_rcntrc.ar_frght_acct_no >= m_xcntrc.cost_goods
            then
                # freight account must be with income range
                call fg_err(8) 
                let nxt_fld = "ar_frght_acct_no"
            end if
        end if;

    after_change_in ar_misc_acct_no
        if p_rcntrc.ar_misc_acct_no is not null
        then
            if p_rcntrc.ar_misc_acct_no < m_xcntrc.income or
                p_rcntrc.ar_misc_acct_no >= m_xcntrc.cost_goods
            then
                # misc. AR account must be within income range
                call fg_err(9) 
                let nxt_fld = "ar_misc_acct_no"
            end if
        end if;

    after_change_in cr_cash_acct_no
        if p_rcntrc.cr_cash_acct_no is not null
        then
           if p_rcntrc.cr_cash_acct_no < m_xcntrc.curr_asset or
               p_rcntrc.cr_cash_acct_no >= m_xcntrc.fixed_asset
            then
                # cash account must be within current assets range
                call fg_err(10) 
                let nxt_fld = "cr_cash_acct_no"
            end if
        end if;

    after_change_in cr_disc_acct_no
        if p_rcntrc.cr_disc_acct_no is not null
        then
            if p_rcntrc.cr_disc_acct_no < m_xcntrc.income or
                p_rcntrc.cr_disc_acct_no >= m_xcntrc.cost_goods
            then
                # discount account must be within income range
                call fg_err(11) 
                let nxt_fld = "cr_disc_acct_no"
            end if
        end if;

    after_field disc_misc
        if (p_rcntrc.disc_misc != "Y" and
            p_rcntrc.disc_misc != "N") or
            p_rcntrc.disc_misc is null 
        then 
            let p_rcntrc.disc_misc = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "disc_misc"
            return
        end if;

    after_field disc_frght
        if (p_rcntrc.disc_frght != "Y" and
            p_rcntrc.disc_frght != "N") or
            p_rcntrc.disc_frght is null 
        then 
            let p_rcntrc.disc_frght = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "disc_frght"
            return
        end if;

    after_field disc_tax
        if (p_rcntrc.disc_tax != "Y" and
            p_rcntrc.disc_tax != "N") or
            p_rcntrc.disc_tax is null 
        then 
            let p_rcntrc.disc_tax = null
            call lib_error("lib_scr", "lookup", 1, "")
            let nxt_fld = "disc_tax"
            return
        end if;
