######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  %Z%  %M%  %I%  Delta: %G%
######################################################################

globals "globals.4gl"

######################################################################
function mlh_init()
# returning the initial find group filter string.
######################################################################
# This function serves two purposes.
# It is called only once upon program invocation, so you may use
# it as a place to run initialization routines.
# It requires a return value of the default select group.
# examples of return values:
#   return "1=1" (select all rows)
#   return "1=0" (select no rows)
#   return "customer_num is not null" (select non-null customer_num's)
#   return "posted = \"N\"" (select only unposted documents)
#
    # Trap fatal errors
    whenever error call error_handler

    return "1=0"
end function
# mlh_init()

######################################################################
function mlh_clear()
######################################################################
#
    initialize p_ropend.* to null
    initialize q_ropend.* to null
    initialize m_ropend.* to null
end function
# mlh_clear

######################################################################
function mlh_construct()
# returning criteria
######################################################################
#
    construct scratch
      on
        stropend.cust_code, stropend.inv_no, stropend.doc_no,
        stropend.inv_desc, stropend.inv_date, stropend.orig_amount,
        stropend.disc_amt, stropend.balance, stropend.disc_bal,
        stropend.due_date, stropend.disc_date, stropend.ar_acct_no,
        stropend.ar_department, stropend.po_no, stropend.po_date
      from
        s_ropend.cust_code, s_ropend.inv_no, s_ropend.doc_no,
        s_ropend.inv_desc, s_ropend.inv_date, s_ropend.orig_amount,
        s_ropend.disc_amt, s_ropend.balance, s_ropend.disc_bal,
        s_ropend.due_date, s_ropend.disc_date, s_ropend.ar_acct_no,
        s_ropend.ar_department, s_ropend.po_no, s_ropend.po_date
    return scratch[1,512]
end function
# mlh_construct

######################################################################
function mlh_cursor()
######################################################################
# This function defines the table, filter, and ordering portions of
# the select statement used to build the FourGen scroller.
#
    call put_vararg("stropend")
    call put_vararg("")
    call put_vararg("cust_code")
end function
# mlh_cursor()

######################################################################
function mlh_key()
# returning tablename, key_field [,key_field]... in (vararg) scratch
######################################################################
# This function returns (in vararg scratch) the name of the main table
# for this screen and the field name(s) and their data that build
# the unique key into this table.
# This is used to determine the unique key for additional fields,
# notes, and other items that may key off this document.  The key
# field(s) must not exceed 30 characters total.
# The first vararg call is the table name.  The following varargs are
# called in pairs.  The first of the pair is the column name, and
# the second in the pair is the column data.
#
    call put_vararg("stropend")
    call put_vararg("cust_code")
    call put_vararg(m_ropend.cust_code)
end function
# mlh_key()
