######################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_opend.4gs/options.4gl  1.8  Delta: 2/8/91
######################################################################

globals "globals.4gl"

define 
    in_zoom   smallint,
    old_cust_code like strcustr.cust_code,
    old_on_acct like strcustr.on_acct_amt

######################################################################
function ring_options(ring_rowid, ring_cursor, ring_total)
# returning ring_rowid, ring_cursor, ring_total
######################################################################
# This function is called when 'Options' is selected from the menu.
# Local menu options are to be added to this menu.
#
    define
        ring_rowid  integer,    # The rowid of the current document
                                # (or -1 if no document is displayed)
        ring_cursor integer,    # The absolute address of the cursor
                                # (0 if document isn't part of the
                                # current cursor group)
        ring_total  integer     # Total number of elements in the cursor

    # Trap fatal errors
    whenever error call error_handler

    menu " Options"
        command key (a)
            "Activity" " View a/p activity"
            if ring_rowid = -1
            then
                continue menu
            end if
            if p_ropend.cust_code is null
            then
                continue menu
            end if
            let scratch = 
                 " stxtranr.ref_code = \"", p_ropend.cust_code, "\""
            if zoom("aractvz","(see scratch)")
            then end if
            exit menu
      command key (o)
        "On Account" " Change amount on account for a customer"
        if m_rcntrc.ar_balanced = "Y"
        then
            call fg_err(6) # Amount on account cannot be changed
            continue menu
        end if
        open window win3 at 2,3
            with form "on_acct"
            attribute (border, blue)
        display "On Account:  [ESC] to store  [DEL] to cancel" at 1,2
        display "======================================",
                "======================================" at 3,1
        if p_ropend.cust_code is not null
        then
            select cust_code, bus_name, on_acct_amt, acct_bal
                into p_rcustr.*
                from strcustr where cust_code = p_ropend.cust_code
            if sqlca.sqlcode = notfound
            then
                let sqlca.sqlcode = 0
                initialize p_rcustr.* to null
            else
                if is_trx()
                  then begin work end if
                if not cust_lock(p_rcustr.cust_code)
                then
                    call fg_error("r_menu", "r_update", 4) 
                    initialize p_rcustr.* to null
                end if
            end if
        else
            initialize p_rcustr.* to null
        end if

        let in_zoom = false
        input p_rcustr.* without defaults from s_rcustr.*
            on key (control-e)
                call fg_err(0)
            on key (control-w)
                call fg_help(2)
            on key (control-z)
                if infield(cust_code)
                then
                    let in_zoom = true
                    let old_cust_code = p_rcustr.cust_code
                    if zoom("custz","")
                    then 
                        let p_rcustr.cust_code = scratch
                    else
                        let p_rcustr.cust_code = old_cust_code
                    end if
                    display by name p_rcustr.cust_code
                    next field cust_code
                end if
            before field cust_code
                display "" at 2,1
                display "Enter any customer code    " at 2,2
                if in_zoom
                then
                    let in_zoom = false
                else
                    let old_cust_code = p_rcustr.cust_code
                end if
            after field cust_code
                if p_rcustr.cust_code is null
                then
                    call fg_err(1) # Customer code must be entered
                    let p_rcustr.cust_code = old_cust_code
                    next field cust_code
                end if
                if p_rcustr.cust_code = old_cust_code
                then else
                    select cust_code,
                           bus_name,
                           on_acct_amt,
                           acct_bal
                      into p_rcustr.*
                      from strcustr
                      where cust_code = p_rcustr.cust_code
                    if sqlca.sqlcode = notfound
                    then
                        let sqlca.sqlcode = 0
                        call fg_err(3) # Invalid customer code
                        let p_rcustr.cust_code = old_cust_code
                        display by name p_rcustr.cust_code
                        next field cust_code
                    end if
                    if not cust_lock(p_rcustr.cust_code)
                    then
                        call fg_error("r_menu", "r_update", 4) 
                        let p_rcustr.cust_code = old_cust_code
                        initialize p_rcustr.* to null
                        let in_zoom = true
                        next field cust_code
                    end if
                    display p_rcustr.* to s_rcustr.*
                end if
            before field on_acct_amt
                display "" at 2,1
                display "Enter new on account amount" at 2,2
                if p_rcustr.on_acct_amt is null
                then
                    let p_rcustr.on_acct_amt = 0
                    display by name p_rcustr.on_acct_amt
                end if
                let old_on_acct = p_rcustr.on_acct_amt
            after field on_acct_amt
                let p_rcustr.on_acct_amt = round( "a",
                    p_rcustr.on_acct_amt )
                if p_rcustr.acct_bal is null
                then
                    let p_rcustr.acct_bal = 0
                end if
                let p_rcustr.acct_bal = p_rcustr.acct_bal -
                    old_on_acct + p_rcustr.on_acct_amt
                display by name p_rcustr.acct_bal
        end input
        if not int_flag
        then
            update strcustr
                set on_acct_amt = p_rcustr.on_acct_amt,
                    acct_bal    = p_rcustr.acct_bal
            where cust_code = p_rcustr.cust_code
        end if
        call cust_unlock()
        if is_trx()
          then commit work end if
        close window win3
        if p_rcustr.cust_code = p_ropend.cust_code
        then
            let p_ropend.on_acct_amt = p_rcustr.on_acct_amt
            let p_ropend.acct_bal = p_rcustr.acct_bal
            display by name p_ropend.on_acct_amt, p_ropend.acct_bal
        end if
        exit menu
      command key (e,x,q,interrupt) "Quit" " Return to the main menu"
        label m_quit:
        let int_flag = 0
        exit menu

      # Event trapping logic
      command key (control-b) let hotkey = 2  goto event
      command key (control-e) let hotkey = 5  goto event
      command key (control-f) let hotkey = 6  goto event
      command key (control-g) let hotkey = 7  goto event
      command key (control-i) let hotkey = 9  goto event
      command key (control-n) let hotkey = 14 goto event
      command key (control-o) let hotkey = 15 goto event
      command key (control-p) let hotkey = 16 goto event
      command key (control-t) let hotkey = 20 goto event
      command key (control-u) let hotkey = 21 goto event
      command key (control-v) let hotkey = 22 goto event
      command key (control-w) let hotkey = 23 goto event
      command key (control-y) let hotkey = 25 goto event
      command key (control-z) let hotkey = 26 goto event
      command key (f1)  let hotkey = 101 goto event
      command key (f2)  let hotkey = 102 goto event
      command key (f3)  let hotkey = 103 goto event
      command key (f4)  let hotkey = 104 goto event
      command key (f5)  let hotkey = 105 goto event
      command key (f6)  let hotkey = 106 goto event
      command key (f7)  let hotkey = 107 goto event
      command key (f8)  let hotkey = 108 goto event
      command key (f9)  let hotkey = 109 goto event
      command key (f10) let hotkey = 110 goto event
      command key (f11) let hotkey = 111 goto event
      command key (f12) let hotkey = 112 goto event
      command key (f13) let hotkey = 113 goto event
      command key (f14) let hotkey = 114 goto event
      command key (f15) let hotkey = 115 goto event
      command key (f16) let hotkey = 116 goto event
      command key (f34) let hotkey = 134 goto event
      command key (f35) let hotkey = 135 goto event
      command key (f36) let hotkey = 136 goto event

      # Local event processing
      label event:
        call hot_local("help")        # Process help locally
        call hot_key("ring_options")  # Map the key to the event
        case
          when scr_funct = "help" call fg_help(1)
          when scr_funct = "cancel" or scr_funct = "m_quit" goto m_quit
        end case

    end menu
    return ring_rowid, ring_cursor, ring_total
end function
# ring_options()
