########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/i_opend.4gs/screen.trg  1.3  Delta: 2/9/91
########################################################################
defaults

    define  
        m_rcntrc record like strcntrc.*,  # record holding GL control info
        p_rcustr record
            cust_code like strcustr.cust_code,
            bus_name like strcustr.bus_name,
            on_acct_amt like strcustr.on_acct_amt,
            acct_bal like strcustr.acct_bal
            end record;

    libraries
        ../../all.4gm/lib.a;

    switchbox_items
        arinvcz arinvcz() # ar invoice detail
        ariactz ariactz() # ar invoice activity
        aronacz aronacz() # ar on account activity
        cractvz cractvz() # cr activity
        aractvz aractvz() # ar activity 
        arshipz arshipz() # ship to;

    after_init
        call rcontrol() returning m_rcntrc.*;

input 1
    on_disk_add
          update strcustr
            set
              on_acct_amt = p_ropend.on_acct_amt,
              acct_bal = p_ropend.acct_bal
            where strcustr.cust_code = p_ropend.cust_code ;

    on_disk_update
        if sqlca.sqlcode = 0
        then
          update strcustr
            set
              on_acct_amt = p_ropend.on_acct_amt,
              acct_bal = p_ropend.acct_bal
            where strcustr.cust_code = p_ropend.cust_code 
        end if

    before_input
        if p_ropend.doc_no is null
        then
            let p_ropend.doc_no = auto_next("strcntrc","ar_doc_no")
        end if;

    after_field ar_department
        if p_ropend.ar_department is null
          then let p_ropend.ar_department = "000" end if;

    after_field cust_code
        if menu_item = "update" and p_ropend.cust_code != prev_data
        then
            # Cannot change customer code
            call fg_err(2)
            let nxt_fld = "cust_code"
            return
        end if;

    after_change_in cust_code
        if p_ropend.cust_code is null
        then
            # Customer code must be entered
            call fg_err(1) 
            let nxt_fld = "cust_code"
            return
        end if

        if not cust_lock(p_ropend.cust_code)  # Attempt to lock strcustr row
        then
            # Customer is currently being updated.
            call fg_error("r_menu", "r_update", 4) 
            let nxt_fld = "cust_code"
            return
        end if

        call get_cust()

        if p_ropend.balance is not null
        then
            let p_ropend.acct_bal = p_ropend.acct_bal +
                p_ropend.balance
        end if;

    before_field on_acct_amount
        if p_ropend.on_acct_amt is null
          then let p_ropend.on_acct_amt = 0 end if
        if p_ropend.acct_bal is null
          then let p_ropend.acct_bal = 0 end if;
        
    after_change_in on_acct_amt
        let p_ropend.on_acct_amt = round("a", p_ropend.on_acct_amt)
        if p_ropend.on_acct_amt is null
          then let p_ropend.on_acct_amt = 0 end if
        let p_ropend.acct_bal = p_ropend.acct_bal - prev_data +
            p_ropend.on_acct_amt;

    after_change_in inv_date
        # make sure g/l is installed
        if table_exist("stgcntrc") 
        then
            # check to see if document date is within
            #   current period
            if per_warn(p_ropend.inv_date) = true
            then
               # Warning:  Date Outside Current Period.
               call fg_err(13)
            end if
        end if;

    after_change_in orig_amount
        let p_ropend.orig_amount = round("a", p_ropend.orig_amount)
        if p_ropend.orig_amount is null 
          then let p_ropend.orig_amount = 0 end if
        call amount_validate(1);

    after_change_in disc_amt
        let p_ropend.disc_amt = round("a", p_ropend.disc_amt)
        if p_ropend.disc_amt is null 
          then let p_ropend.disc_amt = 0 end if
        call amount_validate(2);

    before_field balance
        if p_ropend.balance is null
          then let p_ropend.balance = 0 end if;

    after_change_in balance
        let p_ropend.balance = round("a", p_ropend.balance)
        if p_ropend.balance is null 
          then let p_ropend.balance = 0 end if
        let p_ropend.acct_bal = p_ropend.acct_bal - prev_data +
            p_ropend.balance
        call amount_validate(3);
 
    after_change_in disc_bal
        let p_ropend.disc_bal = round("a", p_ropend.disc_bal)
        if p_ropend.disc_bal is null 
          then let p_ropend.disc_bal = 0 end if
        call amount_validate(4);

    after_input
        if mustfill(p_ropend.cust_code,"Customer Code")
          then let nxt_fld = "cust_code" return end if
        if mustfill(p_ropend.inv_no,"Invoice number")
          then let nxt_fld = "inv_no" return end if
        if mustfill(p_ropend.inv_date,"Invoice date")
          then let nxt_fld = "inv_date" return end if
        if mustfill(p_ropend.due_date,"Invoice due date")
          then let nxt_fld = "due_date" return end if
        call amount_validate(5)
        if tab_pressed = false
        then
            call cust_unlock()
        end if;

    on_event cancel
      call cust_unlock()
      if no_cancel()
      then
        let int_flag = false
        let nxt_fld = null
      else
        let int_flag = true
        let nxt_fld = "exit input"
      end if;
