######################################################################
# This is the area that you would put copyright messages and/or
# SCCS header information.  The text is stored in the file
# $fg/codegen/data/default.dat/sccs  Example:
#
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/lib.4gs/aronacz.4gl  1.1  Delta: 1/4/91
######################################################################

globals "globals.4gl"

# Local (static) variables
define
    sql_join char(512),   # join criteria
    arr_cnt integer,      # Number of active elements in program array
    arr_max integer,      # Maximum available elements in program array
    p_aronacz array[100] of record
        doc_type like strtranr.doc_type,
        doc_no like stxtranr.doc_no,
        inv_chk_no like strtranr.inv_chk_no,
        doc_date like stxtranr.doc_date,
        amount like stractvd.amount
    end record

######################################################################
function aronacz()
######################################################################
# This is a FourGen:Screen function switching mechanism.
# It's job is to route requests from the screen manager to the
# appropriate local function.
#
    # Trap fatal errors
    whenever error call error_handler

    case
      when scr_funct = "init" call Aaronacz()
      when scr_funct = "read" call Raronacz()
      when scr_funct = "display array" call Daronacz()
      when scr_funct = "construct" call Qaronacz()
      when scr_funct = "close" call Zaronacz()
      otherwise let scratch = "no function"
    end case
end function
# aronacz()

######################################################################
function Aaronacz()
######################################################################
# This is the zoom initialization function.
# It opens the window and displays the form.
#
    define
        cust_code like strcustr.cust_code,
        bus_name like strcustr.bus_name,
        y_pos smallint,  # window y position
        x_pos smallint   # window x position

    # Initialize variables
    call put_scrlib("module", "ar")
    let arr_cnt = 0
    let arr_max = 100
    let sql_order  = "doc_date desc, doc_type"
    let sql_join = scratch clipped

    # Open the window and present the form
    call window_pos(5,15) returning y_pos, x_pos
    open window w_aronacz at y_pos, x_pos with form "../lib.4gs/aronacz"
      attribute (white, border)

    let scratch = "select strcustr.cust_code, strcustr.bus_name ",
      "from strcustr, stxtranr where ",
      sql_join clipped, " and strcustr.cust_code = stxtranr.ref_code"

    prepare getcust from scratch
    declare get_name cursor for getcust
    open get_name
    fetch get_name into cust_code, bus_name

    display " ",cust_code clipped, " -  ", bus_name at 1,1

    call menu_line()

end function
# Aaronacz()

######################################################################
function Qaronacz()
######################################################################
# This function places the user into the 'Query by Forms' screen.
#
    construct scratch
      on
        strtranr.doc_type, stxtranr.doc_no, strtranr.inv_chk_no,
        stxtranr.doc_date, stractvd.amount
      from
        s_onact.doc_type, s_onact.doc_no, s_onact.inv_chk_no,
        s_onact.doc_date, s_onact.amount
end function
# Qaronacz()

######################################################################
function Raronacz()
######################################################################
# This function builds and executes the SQL query.
#
    # Build the SQL string
    let scratch = "select ",
        "strtranr.doc_type, stxtranr.doc_no, strtranr.inv_chk_no, ",
        "stxtranr.doc_date, stractvd.amount ",
        "from strtranr, stxtranr, stractvd where ",
        "stxtranr.doc_no = stractvd.doc_no and ",
        "stxtranr.orig_journal = stractvd.orig_journal and ",
        "stxtranr.doc_no = strtranr.doc_no and ",
        "stxtranr.orig_journal = strtranr.orig_journal and ",
        "stractvd.act_type != \"D\" and ",
        "stractvd.inv_doc_no = 0 and ",
        sql_join clipped, " and ", sql_filter clipped, sql_order clipped

    # Prepare the SQL string for execution
    prepare a_aronacz from scratch
    declare c_aronacz cursor for a_aronacz

    # Read the elements into the program array
    let arr_cnt = 0
    foreach c_aronacz into p_aronacz[arr_cnt + 1].*
        let arr_cnt = arr_cnt + 1
        if arr_cnt = arr_max
        then
            call scr_error("overflow",arr_max)
            exit foreach
        end if
    end foreach
    close c_aronacz

    # Return the number of elements
    let scratch = arr_cnt

end function
# Raronacz()

######################################################################
function Daronacz()
# returning true if the zoom function should exit.
######################################################################
# This function calls the display array.  If the user selects the row
# by pressing [ESC] or if they press [DEL] to cancel the operation,
# it informs the screen manager to exit this screen by setting
# int_flag to true.
# If they press [TAB], the screen manager places the user into the
# zoom ring menu.
#
    define
        exit_type char(5)  # Exit types: "quit" or "tab"

    # Setup for display array
    let exit_type = "quit"

    display array p_aronacz to s_onact.*
      attribute(red)

      # Event trapping logic
      on key (control-b) let hotkey = 2  goto event
      on key (control-e) let hotkey = 5  goto event
      on key (control-f) let hotkey = 6  goto event
      on key (control-g) let hotkey = 7  goto event
      on key (control-i) let hotkey = 9  goto event
      on key (control-n) let hotkey = 14 goto event
      on key (control-o) let hotkey = 15 goto event
      on key (control-p) let hotkey = 16 goto event
      on key (control-t) let hotkey = 20 goto event
      on key (control-u) let hotkey = 21 goto event
      on key (control-v) let hotkey = 22 goto event
      on key (control-w) let hotkey = 23 goto event
      on key (control-y) let hotkey = 25 goto event
      on key (control-z) let hotkey = 26 goto event
      on key (f5)  let hotkey = 105 goto event
      on key (f6)  let hotkey = 106 goto event
      on key (f7)  let hotkey = 107 goto event
      on key (f8)  let hotkey = 108 goto event
      on key (f9)  let hotkey = 109 goto event
      on key (f10) let hotkey = 110 goto event
      on key (f11) let hotkey = 111 goto event
      on key (f12) let hotkey = 112 goto event
      on key (f13) let hotkey = 113 goto event
      on key (f14) let hotkey = 114 goto event
      on key (f15) let hotkey = 115 goto event
      on key (f16) let hotkey = 116 goto event
      on key (f34) let hotkey = 134 goto event
      on key (control-m, f35) let hotkey = 135 goto event
      on key (interrupt, f36) let hotkey = 136 goto event

      # Local event processing
      label event:
        call hot_key("aronacz")  # Map the key to the event
        case
          when scr_funct = "zoom"
            let p_cur = arr_curr()
            if p_aronacz[p_cur].doc_type = "CR"
            then
                call put_vararg(p_aronacz[p_cur].doc_no)
                call put_vararg(p_aronacz[p_cur].inv_chk_no)
                call put_vararg(p_aronacz[p_cur].doc_date)
                call put_vararg(p_aronacz[p_cur].amount)
                if zoom("cractvz","dummy")
                then end if
            else
                let scratch = 
                 " stropend.doc_no = ", p_aronacz[p_cur].doc_no
                if zoom("arinvcz","(see scratch)")
                then end if
            end if
          when scr_funct = "accept" exit display
          when scr_funct = "tab" or scr_funct = "btab"
            let exit_type = "tab"
            exit display
          when scr_funct = "cancel"
            let int_flag = true
            exit display
        end case

    end display

    # Return the exit type in scratch
    let scratch = exit_type

end function
# Daronacz()

######################################################################
function Zaronacz()
######################################################################
# This function is called upon return from this screen
#
    # Close the window and make the data available
    close window w_aronacz
    if p_cur = 0
      then let scratch = ""
      else let scratch = p_aronacz[p_cur].doc_no
    end if
end function
# Zaronacz()
