########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../ar.4gm/lib.4gs/cust_lock.4gl  1.2  Delta: 2/6/91
########################################################################

globals "globals.4gl"

define
   locked_cust char(1)

#######################################################################
function cust_lock(p_cust_code)
#######################################################################
# This function opens a cursor for update.   Because the customer 
# ship-to record is fetched with an update cursor the customer 
# record is locked.  The sole purpose of this function is to lock the 
# record (not read it).
#
    define
        p_cust_code like strshipr.cust_code,    # customer code to read
        getid       integer,                    # something to fetch
        sql_str     char(128),
        quote       char(1),
        p_counter   smallint

    # Trap fatal errors
    whenever error call error_handler

    let quote = "\""

    let sql_str = "select rowid from strcustr ",
               "where cust_code = ", 
               quote, p_cust_code, quote, " for update"

    prepare cust_get from sql_str

    declare cust_lock cursor for cust_get
    open cust_lock

    fetch cust_lock into getid

    if sqlca.sqlcode = notfound then return false end if

    let locked_cust = "Y"

    return true
end function
# cust_lock()

#######################################################################
function cust_unlock()
#######################################################################
#
    if locked_cust = "Y"
    then
        close cust_lock
    end if
end function
# cust_unlock()
