########################################################################
# Sccsid:  @(#)  .../ar.4gm/o_custdt.4gs/report.4gl  1.8  Delta: 2/8/91
########################################################################

globals "globals.4gl"

#######################################################################
report report1(rpt)
#######################################################################
#
    define
        rpt record                  # record for the report
            co_name like stxcntrc.co_name,
            cust_code like strcustr.cust_code,
            bus_name like strcustr.bus_name,
            contact like strcustr.contact,
            phone like strcustr.phone,
            address1 like strcustr.address1,
            taxable like strcustr.taxable,
            fin_chg like strcustr.fin_chg,
            address2 like strcustr.address2,
            credit_limit like strcustr.credit_limit,
            acct_bal like strcustr.acct_bal,
            city like strcustr.city,
            state like strcustr.state,
            zip like strcustr.zip,
            country like strcustr.country,
            on_acct_amt like strcustr.on_acct_amt,
            ar_acct_dflt like strcustr.ar_acct_dflt,
            ar_department_dflt like strcustr.ar_department_dflt,
            terms_code like strcustr.terms_code,
            trd_ds_code like strcustr.trd_ds_code,
            disc_desc char(30),
            sls_psn_code like strcustr.sls_psn_code,
            sls_psn_name char(30),
            pay_method like strcustr.pay_method,
            exp_date like strcustr.exp_date,
            card_no like strcustr.card_no,
            card_holder like strcustr.card_holder,
            st_tx_code like strcustr.st_tx_code,
            co_tx_code like strcustr.co_tx_code,
            ci_tx_code like strcustr.ci_tx_code,
            comm_code like strcustr.comm_code,
            comm_desc char(30),
            stmt_amount like strcustr.stmt_amount,
            stmt_cycle like strcustr.stmt_cycle,
            act_grp like strcustr.act_grp,
            ar_type like strcustr.ar_type,
            stmt_date like strcustr.stmt_date,
            last_pay_date like strcustr.last_pay_date,
            terms_desc like strtermr.terms_desc,
            grp_desc like stxactgr.grp_desc,
            ship_to_code like strshipr.ship_to_code,
            ship_bus_name like strshipr.bus_name,
            ship_contact like strshipr.contact,
            ship_address1 like strshipr.address1,
            ship_phone like strshipr.phone,
            ship_address2 like strshipr.address2,
            ship_city like strshipr.city,
            ship_state like strshipr.state,
            ship_zip like strshipr.zip,
            ship_country like strshipr.country,
            ship_taxable like strshipr.taxable,
            ship_trd_ds_code like strshipr.trd_ds_code,
            ship_disc_desc char(30),
            ship_sls_psn_code like strshipr.sls_psn_code,
            ship_sls_name char(30),
            ship_comm_code like strshipr.comm_code,
            ship_comm_desc char(30),
            ship_st_tx_code like strshipr.st_tx_code,
            ship_co_tx_code like strshipr.co_tx_code,
            ship_ci_tx_code like strshipr.ci_tx_code 
        end record,
        scratch     char(255),      # scratch string workspace
        dynamic     smallint,       # boolean: Print this line?
        x           smallint        # working number

    output
        left margin     0
        right margin    80

    order external by rpt.cust_code, rpt.ship_to_code

    format
        page header
            print
                column   1, "Date: ",
                column   7, today using "mm/dd/yy";
                let scratch = "Customer Information Detail"
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped
            print
                column   1, "Time: ",
                column   7, time;
                let scratch = rpt.co_name
                let x = 40 - (length(scratch) / 2)
                print
                    column   x, scratch clipped;
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped
            print
                column   1, "========================================",
                column  41, "========================================"

        page trailer
            print
            print
                column   1, "========================================",
                column  41, "========================================"
            print
                column   1, "Customer Information Detail";
                let scratch = pageno using "Page: <<<<"
                let x = 81 - length(scratch)
                print
                    column   x, scratch clipped

        before group of rpt.cust_code
            skip to top of page
            need 21 lines
            print
            print
                column   9, "Customer Code: ",
                column  24, rpt.cust_code
            print
                column   9, "Business Name: ",
                column  24, rpt.bus_name,
                column  58, "Taxable? ",
                column  67, rpt.taxable
            print
                column  15, "Contact: ",
                column  24, rpt.contact,
                column  48, "Phone: ",
                column  55, rpt.phone
            print
                column  13, "Address 1: ",
                column  24, rpt.address1
            print
                column  13, "Address 2: ",
                column  24, rpt.address2
            print
                column   6, "City, State, Zip: ",
                column  24, rpt.city,
                column  46, rpt.state,
                column  50, rpt.zip
            print
                column  15, "Country: ",
                column  24, rpt.country
            print
                column   5, "Open Item/Bal Fwd: ",
                column  24, rpt.ar_type,
                column  44, "Last Statement Date: ",
                column  65, rpt.stmt_date using "mm/dd/yy"
            print
                column   7, "Statement Cycle: ",
                column  24, rpt.stmt_cycle using "#",
                column  42, "Last Statement Amount: ",
                column  65, rpt.stmt_amount
            print
                column   7, "Finance Charges? ",
                column  24, rpt.fin_chg,
                column  46, "Last Payment Date: ",
                column  65, rpt.last_pay_date using "mm/dd/yy"
            print
                column  10, "Credit Limit: ",
                column  24, rpt.credit_limit,
                column  46, "On Account Amount: ",
                column  65, rpt.on_acct_amt
            print
                column   3, "Default A/R Account: ",
                column  24, rpt.ar_acct_dflt using "######",
                column  30, "-",
                column  31, rpt.ar_department_dflt,
                column  48, "Current Balance: ",
                column  65, rpt.acct_bal
            print
                column  12, "Terms Code: ",
                column  24, rpt.terms_code,
                column  33, rpt.terms_desc
            print
                column   9, "Discount Code: ",
                column  24, rpt.trd_ds_code,
                column  33, rpt.disc_desc
            print
                column   6, "Salesperson Code: ",
                column  24, rpt.sls_psn_code,
                column  33, rpt.sls_psn_name
            print
                column   7, "Commission Code: ",
                column  24, rpt.comm_code,
                column  33, rpt.comm_desc
            print
                column   9, "Account Group: ",
                column  24, rpt.act_grp,
                column  33, rpt.grp_desc
            print
                column   8, "Payment Method: ",
                column  24, rpt.pay_method,
                column  32, "-Expires: ",
                column  42, rpt.exp_date
            print
                column  11, "Card Number: ",
                column  24, rpt.card_no
            print
                column  12, "Cardholder: ",
                column  24, rpt.card_holder
            print
                column  19, "Tax:",
                column  25, "State:",
                column  31, rpt.st_tx_code,
                column  41, "County:",
                column  48, rpt.co_tx_code,
                column  59, "City:",
                column  64, rpt.ci_tx_code
            print
                column   1, "________________________________________",
                column  41, "________________________________________"

        on every row
            need 12 lines
            if
                rpt.ship_to_code is not null
            then
                print
                    column  14, "Ship-To Code: ",
                    column  28, rpt.ship_to_code
            end if
            if
                rpt.ship_bus_name is not null
             or rpt.ship_taxable is not null
            then
                print
                    column  14, "Ship-To Name: ",
                    column  28, rpt.ship_bus_name,
                    column  63, "Taxable? ",
                    column  72, rpt.ship_taxable
            end if
            if
                rpt.ship_contact is not null
             or rpt.ship_phone is not null
            then
                print
                    column  19, "Contact: ",
                    column  28, rpt.ship_contact,
                    column  52, "Phone: ",
                    column  59, rpt.ship_phone
            end if
            if
                rpt.ship_address1 is not null
            then
                print
                    column  17, "Address 1: ",
                    column  28, rpt.ship_address1
            end if
            if
                rpt.ship_address2 is not null
            then
                print
                    column  17, "Address 2: ",
                    column  28, rpt.ship_address2
            end if
            if
                rpt.ship_city is not null
             or rpt.ship_state is not null
             or rpt.ship_zip is not null
            then
                print
                    column  10, "City, State, Zip: ",
                    column  28, rpt.ship_city,
                    column  50, rpt.ship_state,
                    column  54, rpt.ship_zip
            end if
            if
                rpt.ship_country is not null
            then
                print
                    column  19, "Country: ",
                    column  28, rpt.ship_country
            end if
            if
                rpt.ship_trd_ds_code is not null
             or rpt.ship_disc_desc is not null
            then
                print
                    column  13, "Discount Code: ",
                    column  28, rpt.ship_trd_ds_code,
                    column  37, rpt.ship_disc_desc
            end if
            if
                rpt.ship_sls_psn_code is not null
             or rpt.ship_sls_name is not null
            then
                print
                    column  10, "Salesperson Code: ",
                    column  28, rpt.ship_sls_psn_code,
                    column  37, rpt.ship_sls_name
            end if
            if
                rpt.ship_comm_code is not null
             or rpt.ship_comm_desc is not null
            then
                print
                    column  11, "Commission Code: ",
                    column  28, rpt.ship_comm_code,
                    column  37, rpt.ship_comm_desc
            end if
            if
                rpt.ship_st_tx_code is not null
             or rpt.ship_co_tx_code is not null
             or rpt.ship_ci_tx_code is not null
            then
                print
                    column  15, "Tax:",
                    column  21, "State: ",
                    column  28, rpt.ship_st_tx_code,
                    column  38, "County:",
                    column  45, rpt.ship_co_tx_code,
                    column  56, "City:",
                    column  61, rpt.ship_ci_tx_code
            end if
            print
                column   1, "----------------------------------------",
                column  41, "----------------------------------------"

end report
# report1()
